;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Neminem laedere. Socially damaging behaviours;;;
;;;          and how to contain them           ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;VARIABLES DEFINITION ;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;
globals 
[strictness selection ranking cycle cyclenum agentnum hatchnum inj neutr 
lifedur socinfl punprobnet others parents ]  

turtles-own 
[id dna fitness agentype networktype actiontype dangerousness effhonpayoff punished punproboffset t1 t2 tpi greeneigh redneigh totneigh tpn ce cei newitem1 identical different linknum 
state gnpercent redpercent] 


;;;;;;;;;;;;;;;;;;;;;;
;;;CHECK CONDITION ;;;
;;;;;;;;;;;;;;;;;;;;;;
to-report probability-fn? [p] 
  ifelse (random-float 100) < p 
    [report true]; 
    [report false] 
end


;;;;;;;;;;;;;;;;;;;;;;;
;;; SETUP PROCEDURE ;;;
;;;;;;;;;;;;;;;;;;;;;;;
to setup
 clear-all
 ask patches [set pcolor white]
 set strictness strictn-level   
 set cyclenum 30       
 set lifedur 100        
 set agentnum 100        
 set socinfl soc_infl 
 set hatchnum (agentnum / 50)    
 set punprobnet 0   
 create-turtles (agentnum / 100) * hon_percent                  
    [ setxy random-xcor random-ycor        
      set id who
      set size 1                           
      set fitness random 100                
      set agentype 0
      set actiontype 0 
      set networktype 0
      set identical 0
      set different 0
      set punished 0 
      set ce 0
      set cei 0
      let h random-float 5 + 5
      set dna sort (list (0)(h)(10))set color green set shape "circle" set agentype "honest"
      checkagenttype
      set dangerousness DH_payoff    
      set effhonpayoff Hon_payoff 
      ifelse Maxlinknum = 0 
      [ set linknum 0 ] 
      [set linknum random Maxlinknum + 1]
      ]  
create-turtles (agentnum / 100) * (100 - hon_percent)                  
[ setxy random-xcor random-ycor        
      set id who
      set size 1                        
      set fitness random 100             
      set agentype 0
      set actiontype 0 
      set networktype 0
      set identical 0
      set different 0
      set punished 0 
      set ce 0
      set cei 0
      let d random-float 5
      set dna sort (list (0)(d)(10))set color red set shape "triangle" set agentype "dishonest"
      checkagenttype
      set dangerousness DH_payoff    
      set effhonpayoff Hon_payoff 
      ifelse Maxlinknum = 0 
      [ set linknum 0 ] 
      [set linknum random Maxlinknum + 1]
      ]  
create_link
displaylinknum
arrange_nodes
move
end


;;;;;;;;;;;;;;;;;;;;
;;;LINK CREATION ;;;
;;;;;;;;;;;;;;;;;;;;
to create_link
countneigh
ask turtles
[ set others other turtles with [totneigh < linknum]
  while [(count others > 0) and (totneigh < linknum)]  
          [let node1 one-of others 
           create-link-with node1
           set totneigh (totneigh + 1)
           set [totneigh] of node1 (totneigh + 1) 
    set others other turtles with [totneigh < linknum]]
]
countneigh
end


;;;;;;;;;;;;;;;;;;;;;;;;
;;; START  PROCEDURE ;;; 
;;;;;;;;;;;;;;;;;;;;;;;;
to go                       
counter                     
if cycle = cyclenum [stop]  
  ask turtles [checkagenttype]
  chooseaction                
  launchaction                
  legalpunishment             
  socialinfluence
  plotagents      
if show_link_num? 
  [displaylinknum]
if move? 
  [move]
end

 
;;;;;;;;;;;;;;;;;;;;; 
;;; CYCLE COUNTER ;;;
;;;;;;;;;;;;;;;;;;;;;
to counter 
tick                                                    
if ticks = lifedur [reproduction]                       
if ticks > lifedur [reset-ticks set cycle (cycle + 1)]  
end 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; ACTION CHOICE PROCEDURE  ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to chooseaction
ask turtles 
[ 
  let dice random-float 10                     
   if dice < item 1 dna                        
    [ set state 1 ]                            
  if dice > item 1 dna and dice < item 2 dna   
    [ set state 2 ]                            
]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;ACTION LAUNCH PROCEDURE;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to launchaction
countneigh
ask turtles 
 [if state = 1 [ neutralaction set actiontype "honest" ]
  if state = 2 [ damaging set actiontype "dishonest" ]]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;LINK ARRANGE PROCEDURE ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to arrange_nodes
repeat 1 [
  ask turtles [ 
  let c count my-links
  layout-spring (turtles with [any? link-neighbors]) links 0.03 5 - (c / 4) 1]]
end


;;;;;;;;;;;;;;;;;;;;;
;;;AGENT MOVEMENT ;;;
;;;;;;;;;;;;;;;;;;;;;
to move 
ask turtles
[while [any? other turtles-here]
  [ lt random 360 fd 2 ]
]
end



;;;;;;;;;;;;;;;;;;;;;;;;
;;; NEIGHBORS COUNTER;;;
;;;;;;;;;;;;;;;;;;;;;;;;
to countneigh
  ask turtles 
  [set greeneigh link-neighbors with [color = green] 
   set redneigh link-neighbors with  [color = red]
   set identical count link-neighbors with [agentype = [agentype] of myself]
   set different count link-neighbors with [agentype != [agentype] of myself]
   let gn count greeneigh
   let rn count redneigh
   set totneigh gn + rn
   if gn > rn [set tpn (gn * 100) / totneigh set networktype "honest"]
   if rn > gn [set tpn (rn * 100) / totneigh set networktype "dishonest"]
  ]
end


;;;;;;;;;;;;;;;;;;;
;;;HONEST ACTION;;;
;;;;;;;;;;;;;;;;;;;
to neutralaction
if probability-fn? hon_pay_prob
  [set fitness (fitness + effhonpayoff)   
  ]
end


;;;;;;;;;;;;;;;;;;;;;
;;;DAMAGING ACTION;;;
;;;;;;;;;;;;;;;;;;;;;
to damaging
if probability-fn? Dam_pay_prob
   [let a one-of other turtles      
    let fitn [fitness] of a         
    set [fitness] of a (fitn - dangerousness)    
    set fitness (fitness + dangerousness)        
   ]
end


;;;;;;;;;;;;;;;;
;;;PUNISHMENT ;;;
;;;;;;;;;;;;;;;; 
to legalpunishment 
  countneigh
  ask turtles
  [
   let pundice random-float 100        
   if totneigh > 0
   [
      let gn count greeneigh
      let rn count redneigh
      set gnpercent (gn * 100) / totneigh
      set redpercent (rn * 100) / totneigh
      if gn = rn  [ set punproboffset 0 ]
      if gn > rn  [ set punproboffset (punprobnet / 100) * gnpercent]
      if rn > gn  [ set punproboffset ((punprobnet / 100) * redpercent) * -1 ]
   ]
   if state = 2 and pundice <= punprob + punproboffset
   [
      if strictness = 1
        [ set fitness (fitness  - (dangerousness * 2)) ]    
      if strictness = 2
        [ set fitness (fitness  - dangerousness)]   
      if strictness = 3
        [ set fitness (fitness  - (dangerousness / 2))]
  set punished punished + 1
   ]
  
  ] 
  end




;;;;;;;;;;;;;;;;;;;;;;
;;;SOCIAL INFLUENCE;;;
;;;;;;;;;;;;;;;;;;;;;; 

to socialinfluence 
countneigh
ask turtles
  [calculate_cei 
   set label-color black 
   if agentype = "honest"                             ;; AGENTE ONESTO
       [if networktype = "honest"                          ;; NETWORK onesto
            [ifelse actiontype = "honest"                      ;; azione onesta
              
              [ set newitem1 (item 1 dna + (ce - cei))          
                if newitem1 > 10 [set newitem1 10]
                set dna (replace-item 1 dna newitem1)     
                set label "rinf_onest"] 
              
              [ set newitem1 (item 1 dna + (ce - cei))                ;; azione disonesta
                if newitem1 > 10 [set newitem1 10]
                set dna (replace-item 1 dna newitem1)        
                set label "diss_disonest"]]
        
        if networktype = "dishonest"                      ;; NETWORK disonesto
            [ifelse actiontype = "honest"                     ;; azione onesta
              
              [ set newitem1 (item 1 dna - (ce - cei))                
                if newitem1 > 10 [set newitem1 10]
                set dna (replace-item 1 dna newitem1)     
                set label "diss_onest"] 
              
              [ set newitem1 (item 1 dna - (ce - cei))              ;; azione disonesta
                if newitem1 > 10 [set newitem1 10]
                set dna (replace-item 1 dna newitem1)          
                set label "rinf_disonest"]]               
  
   if agentype = "dishonest"                          ;; AGENTE DISONESTO
       [if networktype = "honest"                           ;; NETWORK onesto
            [ifelse actiontype = "honest"                         ;; azione onesta
              
              [ set newitem1 (item 1 dna + (ce - cei ))          
                if newitem1 > 10 [set newitem1 10]
                set dna (replace-item 1 dna newitem1)     
                set label "rinf_onest"] 
              
              [ set newitem1 (item 1 dna + (ce - cei))           ;; azione disonesta
                if newitem1 > 10 [set newitem1 10]
                set dna (replace-item 1 dna newitem1)        
                set label "diss_disonesta"]]
                      
        if networktype = "dishonest"                           ;; NETWORK disonesto  
             [ifelse actiontype = "honest"                         ;; azione onesta
              
              [ set newitem1 (item 1 dna - (ce - cei))
                if newitem1 > 10 [set newitem1 10]
                set dna (replace-item 1 dna newitem1)     
                set label "diss_onest"]
                 
              [ set newitem1 (item 1 dna - (ce - cei))                  ;; azione disonesta
                if newitem1 > 10 [set newitem1 10]
                set dna (replace-item 1 dna newitem1)
                set label "rinf_disonest"]
          ]
            
         ]
    ]     
]

end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;ACTUAL SOCIAL INFLUENCE ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to calculate_cei
let gn count greeneigh
let rn count redneigh
ifelse gn != rn [
  if gn > rn [set ce (socinfl * gn)]
  if rn > gn [set ce (socinfl * rn)]
  ]
[set ce 0] 
set cei (tpi / 100) * ce 
end



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;GRAPHICS VISUALIZATION ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
to plotagents  
set-current-plot "Agent-type"                       
  set-current-plot-pen "Honests"                    
    plot (count turtles with [ agentype = "honest" ])         
  set-current-plot-pen "Injurers"                   
    plot (count turtles with [ agentype = "dishonest"])         
set-current-plot "Action-type"
  set-current-plot-pen "Honest"
    plot (count turtles with [ actiontype = "honest" ])
  set-current-plot-pen "Dishonest"
    plot (count turtles with [ actiontype = "dishonest" ])
end


;;;;;;;;;;;;;;;;;;
;;;REPRODUCTION;;;
;;;;;;;;;;;;;;;;;;
to reproduction                                           
 countneigh
 set ranking sort-by [[fitness] of ?1 > [fitness] of ?2] turtles  
 set selection sublist ranking 0 50                             
 foreach selection [ask ? 
    [ hatch hatchnum                     
        [ setxy xcor + random-normal 0 2 ycor + random-normal 0 2 
          set fitness random 100          
          set dangerousness DH_payoff    
          set effhonpayoff Hon_payoff
   if maxlinknum > 0
          [set linknum random Maxlinknum + 1] 
          set dna (map [? + random-normal 0 0.05]dna)              
          set dna (replace-item 0 dna 0)                          
          set dna (replace-item 2 dna 10)                         
          set dna sort dna                                        
          if Maxlinknum != 0 
          [set parents other turtles with [(id = [id] of myself) and (totneigh < linknum)]
          while [(count parents > 0) and (totneigh < linknum)]    
          [let node1 one-of parents
          create-link-with node1
          set totneigh (totneigh + 1)
          set [totneigh] of node1 (totneigh + 1) 
          set parents other turtles with [totneigh < linknum]
          ]]]]] foreach ranking [ask ? [die]]                      
countneigh
ask turtles 
[ set others other turtles with [totneigh < linknum]
  while [(count others > 0) and (totneigh < linknum)]  
         [let node1 one-of others 
          create-link-with node1
          set totneigh (totneigh + 1)
          set [totneigh] of node1 (totneigh + 1) 
          set others other turtles with [totneigh < linknum]]
          ]
countneigh
ask turtles 
  [checkagenttype] 
if show_link_num? [ displaylinknum ]

if move? [move]
end
 

;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; LINK NUMBER DISPLAY ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;
to displaylinknum
  ask turtles 
  [  
    set greeneigh link-neighbors with [color = green] 
    set redneigh link-neighbors with  [color = red]
    let gn count greeneigh
    let rn count redneigh
    let l gn + rn 
    set totneigh gn + rn
    set label-color black 
    set label l
  ]
end



;;;;;;;;;;;;;;;;;;;;;;
;;;CHECK AGENT TYPE;;;
;;;;;;;;;;;;;;;;;;;;;;
to checkagenttype
  set t1 item 1 dna 
  set t2 (item 2 dna - item 1 dna)
  if t1 > t2 [set tpi t1]
  if t2 > t1 [set tpi t2] 
   set size (3 * (tpi / 10))
      ifelse item 1 dna >= 5 
        [set color green set shape "circle" set agentype "honest"]
        [set color red set shape "triangle" set agentype "dishonest"]
end





 



@#$#@#$#@
GRAPHICS-WINDOW
278
10
613
366
20
20
7.93
1
10
1
1
1
0
1
1
1
-20
20
-20
20
0
0
1
ticks

CC-WINDOW
5
380
994
475
Command Center
0

SLIDER
892
90
984
123
Strictn-level
Strictn-level
1
3
1
1
1
NIL
HORIZONTAL

SLIDER
764
57
876
90
DH_payoff
DH_payoff
0
5
2
0.1
1
NIL
HORIZONTAL

SWITCH
59
280
166
313
Show_link_num?
Show_link_num?
0
1
-1000

SWITCH
59
316
165
349
Move?
Move?
0
1
-1000

PLOT
21
10
265
189
Agent-type
Ticks
Agent number
0.0
10.0
0.0
100.0
true
false
PENS
"Honests" 1.0 0 -10899396 true
"Injurers" 1.0 0 -2674135 true

SLIDER
632
123
743
156
Hon_percent
Hon_percent
0
100
50
1
1
NIL
HORIZONTAL

BUTTON
874
299
939
332
GO
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
633
244
741
277
Maxlinknum
Maxlinknum
0
10
10
1
1
NIL
HORIZONTAL

BUTTON
807
299
869
332
Setup
Setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
892
57
984
90
Punprob
Punprob
0
100
24
1
1
NIL
HORIZONTAL

MONITOR
694
288
753
333
Honest
count turtles with [color = green]
17
1
11

MONITOR
635
288
691
333
Dishonest
count turtles with [color = red]
17
1
11

SLIDER
633
211
741
244
Soc_infl
Soc_infl
0
0.01
0.01
0.001
1
NIL
HORIZONTAL

PLOT
20
193
265
366
Action-type
Ticks
Action number
0.0
10.0
0.0
100.0
true
false
PENS
"Honest" 1.0 0 -10899396 true
"Dishonest" 1.0 0 -2674135 true

SLIDER
633
90
743
123
Hon_pay_prob
Hon_pay_prob
0
100
100
1
1
NIL
HORIZONTAL

SLIDER
633
57
743
90
Hon_payoff
Hon_payoff
0
5
1
0.1
1
NIL
HORIZONTAL

TEXTBOX
777
133
869
151
Punish. strict. level
11
15.0
1

TEXTBOX
774
145
875
163
1:Strict 2:Fair 3:Lax
11
0.0
1

SLIDER
764
90
876
123
Dam_pay_prob
Dam_pay_prob
0
100
100
1
1
NIL
HORIZONTAL

TEXTBOX
645
35
739
65
Honesty settings
12
13.0
1

TEXTBOX
771
34
873
64
Damaging settings
12
13.0
1

TEXTBOX
895
33
985
63
Punish. settings
12
13.0
1

TEXTBOX
646
190
729
208
Social settings
13
13.0
1

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.0.5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="experiment" repetitions="20" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <metric>count turtles with [color = red]</metric>
    <enumeratedValueSet variable="Strictn-level">
      <value value="1"/>
      <value value="2"/>
      <value value="3"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
